h32777
s 00024/00000/00000
d D 1.1 82/08/02 15:58:07 cecily 1 0
e
u
U
t
T
I 1
shell (n, comp, exch)
	int (*comp)(), (*exch)();
/* SORTS UP.  IF THERE ARE NO EXCHANGES (IEX=0) ON A SWEEP
  THE COMPARISON GAP (IGAP) IS HALVED FOR THE NEXT SWEEP */
{
	int igap, iplusg, iex, i, imax;
	igap=n;
while (igap > 1)
	{
	igap /= 2;
	imax = n-igap;
	do
		{
		iex=0;
		for(i=0; i<imax; i++)
			{
			iplusg = i + igap;
			if ((*comp) (i, iplusg) ) continue;
			(*exch) (i, iplusg);
			iex=1;
			}
		} while (iex>0);
	}
}
E 1
